"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _styles = require("./styles");
var _Dimensions = require("../../constants/Dimensions");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
// import {
//   requireNativeComponent,
//   UIManager,
//   Platform,
//   type ViewStyle,
// } from 'react-native';
// import { getStyles } from './styles';
const horizontalLine = new _reactNative.Animated.Value(0);
const CustomTopTab = _ref => {
  let {
    children,
    pages = ['array'],
    containerStyle,
    scrollTo,
    sectionSwitchStyle,
    sectionSwitchTextStyle,
    backgroundColor,
    tintColor = 'black',
    tintHeight = 12,
    tintRadius = 0,
    switchHeight = 55
  } = _ref;
  const [index, setIndex] = _react.default.useState(0);
  const [pageList] = _react.default.useState(pages);
  const ref = _react.default.useRef(null);
  const styles = (0, _styles.getStyles)({
    length: pageList.length,
    maxItemWidth: _Dimensions.width / 4.2
  });
  let lineOffset = pageList.length > 4 ? _Dimensions.width / 4.2 : _Dimensions.width / pageList.length;
  (0, _react.useEffect)(() => {
    setIndex(pageList === null || pageList === void 0 ? void 0 : pageList[0]);
  }, [pageList]);
  function handleScroll(event) {
    let maxlength = event.nativeEvent.contentOffset.x;
    let currentLength = event.nativeEvent.contentSize.width / pageList.length;
    let scrolledindex = maxlength / currentLength;
    console.log('maxlength', maxlength, ' currentLength', currentLength, ' index', scrolledindex);
    // let currentindex = event.nativeEvent.contentSize.width / pageList.length > event.nativeEvent.contentOffset.x ? 0 : 1
    if (parseInt(scrolledindex) !== parseInt(pageList.indexOf(index))) {
      console.log('scrolledindex', scrolledindex, pageList.indexOf(index));
      setIndex(pageList[scrolledindex]);
    }
  }
  function handleChangeSwitch(params) {
    console.log(params);
    setIndex(params);
  }
  (0, _react.useEffect)(() => {
    var _ref$current;
    let currentIndex = index ? pageList.indexOf(index) : 0;
    console.log('Current Index =', currentIndex, index);
    let abs = Math.abs(currentIndex * _Dimensions.width);
    if (Boolean(ref === null || ref === void 0 || (_ref$current = ref.current) === null || _ref$current === void 0 ? void 0 : _ref$current.scrollTo)) {
      ref.current.scrollTo({
        x: abs,
        y: 0,
        animated: true
      });
    }
    _reactNative.Animated.timing(horizontalLine, {
      toValue: currentIndex * lineOffset,
      duration: 200,
      useNativeDriver: true
    }).start(); // start the animation  
  }, [index]);
  function manualScroll(pageName) {
    console.log('scrollTo', pageName);
    if (pageName) ref.current.scrollTo({
      x: pageName,
      y: 0,
      animated: true
    });
  }
  (0, _react.useEffect)(() => {
    console.log('manualScroll', scrollTo);
    if (scrollTo) {
      manualScroll(scrollTo);
    }
  }, [scrollTo]);
  console.log(typeof backgroundColor);
  function itemstyle(item) {
    let i = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
    return {
      ...styles.switchItemWrapper,
      borderBottomWidth: 0,
      borderBottomColor: index === item ? 'black' : 'transparent',
      backgroundColor: typeof backgroundColor === 'object' ? backgroundColor === null || backgroundColor === void 0 ? void 0 : backgroundColor[i] : backgroundColor
    };
  }
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, null, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: [styles.switchWrapper, {
      height: switchHeight
    }]
  }, /*#__PURE__*/_react.default.createElement(_reactNative.ScrollView, {
    horizontal: true,
    style: [styles.switchContainer, {
      height: switchHeight
    }]
  }, pageList.map((item, i) => /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
    key: i,
    onPress: () => handleChangeSwitch(item),
    style: [itemstyle(item, i), sectionSwitchStyle, {
      backgroundColor: typeof backgroundColor === 'object' ? backgroundColor === null || backgroundColor === void 0 ? void 0 : backgroundColor[i] : backgroundColor
    }]
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: {
      ...styles.switchLabel,
      opacity: `${index}` === item ? 1 : 0.5,
      fontWeight: '400',
      ...sectionSwitchTextStyle
    }
  }, item))), /*#__PURE__*/_react.default.createElement(_reactNative.Animated.View, {
    style: {
      ...styles.switchLine,
      transform: [{
        translateX: horizontalLine
      }],
      borderColor: tintColor,
      borderWidth: tintHeight,
      borderRadius: tintRadius
    }
  }))), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: [styles.contentContainer, containerStyle]
  }, /*#__PURE__*/_react.default.createElement(_reactNative.ScrollView, {
    horizontal: true,
    style: styles.scrollView,
    ref: ref,
    pagingEnabled: true,
    showsHorizontalScrollIndicator: false,
    onMomentumScrollEnd: handleScroll,
    bounces: false,
    scrollEventThrottle: 200
  }, children)));
};
var _default = CustomTopTab;
exports.default = _default;
//# sourceMappingURL=CustomTopSection.js.map